import os
import re
import subprocess
from ffmpeg_to_youtube import *

"""
Convert MP3 to MOV.
This works like a shell script, nothing fancy.
"""

rootdir = '../1raw'
video_format = 'mov'

raw_files = os.listdir(rootdir)

mp3_files = []
for raw_file in raw_files:
    if raw_file[-4:] == '.mp3':
        mp3_files.append(raw_file)

# now assemble our commands
mre = re.compile('mp3$')
mov_files = [ 'movie_'+mre.sub(video_format,mp3_file) for mp3_file in mp3_files]

full_mp3_files = [rootdir + '/' + mp3_file for mp3_file in mp3_files]
full_mov_files = [rootdir + '/' + mov_file for mov_file in mov_files]

img = (rootdir + '/WatergateTimeCover.png')

for mp3,fullmp3,out in zip(mp3_files,full_mp3_files,full_mov_files):
    ffmpeg_to_youtube(fullmp3,img,out)

