import os
import subprocess

class AudioToVideoConverter(object):
    """
    Converts an audio and image file into a video.

    Usage:
        AudioToVideoConverter({'audio_file' : 'aaa',
                              'image_file'  : 'bbb',
                              'output_file' : 'ccc'
                              })
    """
    def __init__(self, d): 
        self.params = d
        self.setup()
        self.doit()

    def setup(self):
        # basically do error-checking
        # make sure image and audio extensions are ok format
        # make sure output is ok format
        if self.params['audio_file'][-3:] <> 'wav':
            raise Exception('error: audio must be wav format')
        if self.params['output_file'][-3:] <> 'mp4':
            raise Exception('error: output must be mp4 format')

    def doit(self):
        # assemble command line stuffs
        subprocess.call(["echo","ffmpeg", 
                "-i",
                self.params['image_file'],
                "-i",
                self.params['audio_file'],
                self.params['output_file']
                ])



class MP3ToWavConverter(object):
    """
    Converts an MP3 to a WAV

    Usage:
    MP3ToWavConverter({'mp3_file' : 'aaa',
                       'wav_file' : 'bbb'
                    })
    """
    def __init__(self, d): 
        self.params = d
        self.setup()
        self.doit()

    def setup(self):
        # basically do error-checking
        # make sure image and audio extensions are ok format
        # make sure output is ok format
        if self.params['mp3_file'][-3:] <> 'mp3':
            raise Exception('error: mp3 file was not an mp3')
        if self.params['wav_file'][-3:] <> 'wav':
            raise Exception('error: wav file was not a wav')

    def doit(self):
        # assemble command line stuffs
        subprocess.call(["echo","ffmpeg", 
                "-i",
                self.params['mp3_file'],
                self.params['wav_file']
                ])




if __name__=="__main__":
    #if len(os.sys.argv) > 1:
    #    if len(os.sys.argv)==4:
    #        image_file = os.sys.argv[1]
    #        audio_file = os.sys.argv[2] 
    #        output_file = os.sys.argv[3]  
    #    else:
    #        raise Exception('wrong # of arguments. need 3.')
    #else:
    #    image_file = 'image.jpg'
    #    audio_file = 'audio.wav'
    #    output_file = 'out.mp4'

    mp3_file = 'audio.mp3'
    wav_file = 'audio.wav'
    wvc = MP3ToWavConverter({
        'mp3_file': mp3_file, 
        'wav_file': wav_file
    })

    image_file = 'image.jpg'
    audio_file = 'audio.wav'
    output_file = 'out.mp4'
    avc = AudioToVideoConverter({
        'image_file': image_file, 
        'audio_file': audio_file,
        'output_file'  : output_file
    })

